
CREATE TABLE SRI_USER(
ID number(19) NOT NULL,
USERNAME varchar2(255) NOT NULL,
PASSWORD varchar2(255) NULL,
SALT varchar2(250) NULL,
ALGORITHM varchar2(50) NULL,
DEFAULT_STORE_ID varchar2(255) NULL,
PRIMARY KEY (ID),
CONSTRAINT AK_USER UNIQUE (USERNAME))
;

CREATE SEQUENCE SRI_USER_ID_SEQ
INCREMENT BY 1
START WITH 1
NOMAXVALUE
MINVALUE 1
NOCYCLE
NOCACHE
NOORDER
;

CREATE OR REPLACE TRIGGER SET_SRI_USER_ID
BEFORE INSERT
ON SRI_USER
FOR EACH ROW
BEGIN
  SELECT SRI_USER_ID_SEQ.NEXTVAL
  INTO :NEW.ID
  FROM DUAL;
END;
/
;

CREATE TABLE ACCESS_RULE(
RULE_NAME varchar2(255) NOT NULL,
PRIMARY KEY (RULE_NAME))
;

CREATE TABLE ACCESS_RULE_IMPLICIT(
RULE_NAME varchar2(255) NOT NULL,
IMPLIES_RULE_NAME varchar2(255) NOT NULL,
PRIMARY KEY (RULE_NAME,IMPLIES_RULE_NAME))
;

CREATE TABLE USER_PERMISSION(
ID number(19) NOT NULL,
RULE_NAME varchar2(255) NOT NULL,
PRIMARY KEY (ID,RULE_NAME))
;

CREATE TABLE MS_STORE(
STORE_ID varchar2(255) NOT NULL,
PRIMARY KEY (STORE_ID))
;

CREATE TABLE MS_STORE_USER(
STORE_ID varchar2(255) NOT NULL,
ID number(19) NOT NULL,
PRIMARY KEY (STORE_ID,ID))
;

CREATE TABLE AUTH_DB_VERSION(
MAJOR number(19) NOT NULL,
MINOR number(19) NOT NULL,
UPGRADE_STAMP timestamp  DEFAULT CURRENT_TIMESTAMP NOT NULL,
PRIMARY KEY (MAJOR,MINOR))
;

ALTER TABLE SRI_USER ADD CONSTRAINT FK_USER_DEFAULT_STORE FOREIGN KEY (DEFAULT_STORE_ID) REFERENCES MS_STORE (STORE_ID)
;

ALTER TABLE USER_PERMISSION ADD CONSTRAINT FK_USER_PERMISSION_USER FOREIGN KEY (ID) REFERENCES SRI_USER (ID)
ON DELETE CASCADE
;

ALTER TABLE USER_PERMISSION ADD CONSTRAINT FK_USER_PERMISSION_RULE FOREIGN KEY (RULE_NAME) REFERENCES ACCESS_RULE (RULE_NAME)
ON DELETE CASCADE
;

ALTER TABLE ACCESS_RULE_IMPLICIT ADD CONSTRAINT FK_PARENT_RULE FOREIGN KEY (RULE_NAME) REFERENCES ACCESS_RULE (RULE_NAME)
ON DELETE CASCADE
;

ALTER TABLE ACCESS_RULE_IMPLICIT ADD CONSTRAINT FK_IMPLICIT_RULE FOREIGN KEY (IMPLIES_RULE_NAME) REFERENCES ACCESS_RULE (RULE_NAME)
;

ALTER TABLE MS_STORE_USER ADD CONSTRAINT FK_USER_MS_STORE FOREIGN KEY (ID) REFERENCES SRI_USER (ID)
ON DELETE CASCADE
;

ALTER TABLE MS_STORE_USER ADD CONSTRAINT FK_MS_STORE_USER FOREIGN KEY (STORE_ID) REFERENCES MS_STORE (STORE_ID)
ON DELETE CASCADE
;

CREATE OR REPLACE PROCEDURE INSERT_SRI_USER(
p_username IN varchar2,
p_password IN varchar2,
p_salt IN varchar2,
p_algorithm IN varchar2,
p_default_store_id IN varchar2,
p_pk OUT number)
AS
BEGIN
		INSERT INTO SRI_USER (USERNAME,PASSWORD,SALT,ALGORITHM,DEFAULT_STORE_ID) VALUES (p_username, p_password, p_salt, p_algorithm, p_default_store_id) RETURNING ID INTO p_pk;
END;
/

;

